package net.windwards.options;

/**
 * Implement this interface to accept non-option arguments from the
 * commandline. For additional information, see
 * {@link net.windwards.options.OptionParser}.
 *
 * @see net.windwards.options.OptionParser
 */
public interface AcceptsArguments {
    /**
     * Method will be called for each non-option argument (e.g. a file)
     * encountered on commandline.
     *
     * @param arg One argument from the commandline
     * @return Return false to inform the parser to stop parsing the
     * commandline. Typically, you would use this because the argument is
     * some kind of subcommand that needs its own OptionParser.
     */
	public boolean handleArgument(String arg);
}
