package net.windwards.options.valueparsers;

import net.windwards.options.OptionDescription;
import net.windwards.options.err.InvalidOptionValue;

/**
 * Created by quest on 2013-06-05.
 */
public class BooleanValueParser implements ValueParser {
    public Object parse(OptionDescription desc, Class<?> type, String value) throws InvalidOptionValue {
        Object valueObj;

        if (value == null) {
            valueObj = !(Boolean)desc.defaultValue;
        } else if (value.equalsIgnoreCase("yes") ||
                value.equalsIgnoreCase("on")) {
            valueObj = true;
        } else if (value.equalsIgnoreCase("no") ||
                value.equalsIgnoreCase("off")) {
            valueObj = false;
        } else {
            throw new InvalidOptionValue("Option --" +
                    desc.longOptionName + " expect yes|no|on|off");
        }
        return valueObj;
    }
}
