package net.windwards.options.valueparsers;

import net.windwards.options.OptionDescription;
import net.windwards.options.err.InvalidOptionValue;

/**
 * Created by quest on 2013-06-05.
 */
public class NumberValueParser implements ValueParser {
    public Object parse(OptionDescription desc, Class<?> type, String value) throws InvalidOptionValue {
        Object valueObj = null;

        if (type == long.class || type == Long.class) {
            try {
                valueObj = new Long(value);
            } catch (NumberFormatException e) {
                throw new InvalidOptionValue(
                        "Option --" + desc.longOptionName +
                                " can't accept value " + value + ".");
            }
        } else if (type == int.class || type == Integer.class) {
            try {
                valueObj = new Integer(value);
            } catch (NumberFormatException e) {
                throw new InvalidOptionValue(
                        "Option --" + desc.longOptionName +
                                " can't accept value " + value + ".");
            }
        } else if (type == short.class || type == Short.class) {
            try {
                valueObj = new Short(value);
            } catch (NumberFormatException e) {
                throw new InvalidOptionValue(
                        "Option --" + desc.longOptionName +
                                " can't accept value " + value + ".");
            }
        } else if (type == float.class || type == Float.class) {
            try {
                valueObj = new Float(value);
            } catch (NumberFormatException e) {
                throw new InvalidOptionValue(
                        "Option --" + desc.longOptionName +
                                " can't accept value " + value + ".");
            }
        } else if (type == double.class || type == Double.class) {
            try {
                valueObj = new Double(value);
            } catch (NumberFormatException e) {
                throw new InvalidOptionValue(
                        "Option --" + desc.longOptionName +
                                " can't accept value " + value + ".");
            }
        }
        return valueObj;
    }
}
