package net.windwards.options.valueparsers;

import net.windwards.options.OptionDescription;
import net.windwards.options.err.InvalidOptionValue;

import java.net.MalformedURLException;
import java.net.URL;

/**
 * Created by quest on 2013-06-05.
 */
public class URLValueParser implements ValueParser {
    public Object parse(OptionDescription desc, Class<?> type, String value) throws InvalidOptionValue {
        if (value == null)
            return desc.defaultValue;

        try {
            return new URL(value);
        } catch (MalformedURLException e) {
            throw new InvalidOptionValue("Malformed URL in --" + desc.longOptionName);
        }
    }
}
